<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/Phenotype.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Phenotype.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_phenotype_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Phenotype.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _PHENOTYPE_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _PHENOTYPE_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* This class represents the structure of a phenotype, as employed by libGE  */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* mappers. As in nearly all cases the output of the GE mapping process will */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">/* be a text generated through the use of a grammar, it made sense to        */</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">/* implement this structure as being an array of characters. This structure  */</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">/* will most likely have to be converted to the output required by the       */</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">/* evaluator used to score phenotype structures.                             */</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="lib_g_edefs_8h.html">libGEdefs.h</a>&quot;</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include&lt;iostream&gt;</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include&lt;string&gt;</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include&lt;vector&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include&quot;<a class="code" href="_symbol_8h.html">Symbol.h</a>&quot;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="_phenotype_8h.html#afad9c6bc3cc1205d1d3876505b595ee6">   23</a></span>&#160;<span class="preprocessor">#define MIN_PHENOTYPE_FITNESS       0.0</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="_phenotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">   25</a></span>&#160;<span class="keyword">typedef</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="_phenotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a>;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_phenotype.html">   29</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_phenotype.html">Phenotype</a>: <span class="keyword">public</span> vector&lt;const Symbol*&gt;{</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <a class="code" href="class_phenotype.html">Phenotype</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>, <span class="keyword">const</span> <a class="code" href="_genotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a>=<a class="code" href="_phenotype_8h.html#afad9c6bc3cc1205d1d3876505b595ee6">MIN_PHENOTYPE_FITNESS</a>);</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <a class="code" href="class_phenotype.html">Phenotype</a>(<span class="keyword">const</span> <a class="code" href="class_phenotype.html">Phenotype</a> &amp;);</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        ~<a class="code" href="class_phenotype.html">Phenotype</a>();</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="keywordtype">bool</span> getValid() <span class="keyword">const</span>;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keywordtype">void</span> setValid(<span class="keyword">const</span> <span class="keywordtype">bool</span>);</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <a class="code" href="_genotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a> getFitness() <span class="keyword">const</span>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordtype">void</span> setFitness(<span class="keyword">const</span> <a class="code" href="_genotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a>);</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="keywordtype">string</span> getString() <span class="keyword">const</span>;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="comment">//const char* c_str() const;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keyword">friend</span> ostream &amp;<a class="code" href="_genotype_8cpp.html#a2ef9edd74075f837dec0cfd45681e0fb">operator&lt;&lt;</a>(ostream &amp;, <span class="keyword">const</span> <a class="code" href="class_phenotype.html">Phenotype</a> &amp;);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordtype">bool</span> _libGE_Phenotype_valid;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <a class="code" href="_genotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a> _libGE_Phenotype_fitness;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;};</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclass_phenotype_html"><div class="ttname"><a href="class_phenotype.html">Phenotype</a></div><div class="ttdef"><b>Definition:</b> Phenotype.h:29</div></div>
<div class="ttc" id="a_genotype_8h_html_ae09c2f0f089f257b93744150b5a503e4"><div class="ttname"><a href="_genotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a></div><div class="ttdeci">long double FitnessType</div><div class="ttdef"><b>Definition:</b> Genotype.h:23</div></div>
<div class="ttc" id="a_phenotype_8h_html_afad9c6bc3cc1205d1d3876505b595ee6"><div class="ttname"><a href="_phenotype_8h.html#afad9c6bc3cc1205d1d3876505b595ee6">MIN_PHENOTYPE_FITNESS</a></div><div class="ttdeci">#define MIN_PHENOTYPE_FITNESS</div><div class="ttdef"><b>Definition:</b> Phenotype.h:23</div></div>
<div class="ttc" id="alib_g_edefs_8h_html"><div class="ttname"><a href="lib_g_edefs_8h.html">libGEdefs.h</a></div></div>
<div class="ttc" id="a_genotype_8cpp_html_a2ef9edd74075f837dec0cfd45681e0fb"><div class="ttname"><a href="_genotype_8cpp.html#a2ef9edd74075f837dec0cfd45681e0fb">operator&lt;&lt;</a></div><div class="ttdeci">ostream &amp; operator&lt;&lt;(ostream &amp;stream, const Genotype &amp;g)</div><div class="ttdef"><b>Definition:</b> Genotype.cpp:177</div></div>
<div class="ttc" id="a_phenotype_8h_html_ae09c2f0f089f257b93744150b5a503e4"><div class="ttname"><a href="_phenotype_8h.html#ae09c2f0f089f257b93744150b5a503e4">FitnessType</a></div><div class="ttdeci">long double FitnessType</div><div class="ttdef"><b>Definition:</b> Phenotype.h:25</div></div>
<div class="ttc" id="a_symbol_8h_html"><div class="ttname"><a href="_symbol_8h.html">Symbol.h</a></div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
